/*
 * Copyright (c) 2020 Huawei Technologies Co.,Ltd.
 *
 * openGauss is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *
 *          http://license.coscl.org.cn/MulanPSL2
 *
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 * ---------------------------------------------------------------------------------------
 * 
 * memory_lite.h
 * 
 * 
 * 
 * IDENTIFICATION
 *        src/include/lite/memory_lite.h
 *
 * ---------------------------------------------------------------------------------------
 */


#ifndef MEMORY_LITE_H
#define MEMORY_LITE_H

#ifdef ENABLE_LITE_MODE
#define PARTITION_OID_INDEX_ID_NBUCKETS 512
#define PARTITION_PART_OID_INDEX_ID_NBUCKETS 512
#define PARTITION_INDEX_TABLE_ID_PARENT_OID_INDEX_ID_NBUCKETS 512
#define PG_JOB_ID_INDEX_ID_NBUCKETS 4
#define PG_OBJECT_INDEX_NBUCKETS 4
#define PGXC_CLASS_PGXC_REL_ID_INDEX_ID_NBUCKETS 4
#define PGXC_GROUP_GROUP_NAME_INDEX_ID_NBUCKETS 4
#define PGXC_GROUP_OID_INDEX_ID_NBUCKETS 4
#define PGXC_NODE_NODE_NAME_INDEX_ID_NBUCKETS 4
#define PGXC_NODE_OID_INDEX_ID_NBUCKETS 4
#define PGXC_NODE_NODE_ID_INDEX_ID_NBUCKETS 4
#define WORKLOAD_GROUP_GROUP_NAME_INDEX_ID_NBUCKETS 4
#define WORKLOAD_GROUP_OID_INDEX_ID_NBUCKETS 4
#define PGXC_SLICE_INDEX_ID_NBUCKETS 4
#define STATISTIC_RELID_KIND_ATTNUM_INH_INDEX_ID_NBUCKETS 4
#define STATISTIC_EXT_RELID_KIND_INH_KEY_INDEX_ID_NBUCKETS 4
#define PACKAGE_OID_INDEX_ID_NBUCKETS 4
#define PACKAGE_NAME_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_DEFRELID_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_ID_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_LOOKUP_ID_XID_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_MATRELID_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_OID_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_RELID_INDEX_ID_NBUCKETS 4
#define STREAMING_CONT_QUERY_SCHEMA_CHANGE_INDEX_ID_NBUCKETS 4
#define STREAMING_STREAM_OID_INDEX_ID_NBUCKETS 4
#define STREAMING_STREAM_RELID_INDEX_ID_NBUCKETS 4
#define STREAMING_REAPER_STATUS_OID_INDEX_ID_NBUCKETS 4
#define STREAMING_CQ_REAPER_STATUS_OID_INDEX_ID_NBUCKETS 4

#else

#define PARTITION_OID_INDEX_ID_NBUCKETS 1024
#define PARTITION_PART_OID_INDEX_ID_NBUCKETS 1024
#define PARTITION_INDEX_TABLE_ID_PARENT_OID_INDEX_ID_NBUCKETS 1024
#define PG_JOB_ID_INDEX_ID_NBUCKETS 2048
#define PG_OBJECT_INDEX_NBUCKETS 2048
#define PGXC_CLASS_PGXC_REL_ID_INDEX_ID_NBUCKETS 1024
#define PGXC_GROUP_GROUP_NAME_INDEX_ID_NBUCKETS 256
#define PGXC_GROUP_OID_INDEX_ID_NBUCKETS 256
#define PGXC_NODE_NODE_NAME_INDEX_ID_NBUCKETS 256
#define PGXC_NODE_OID_INDEX_ID_NBUCKETS 256
#define PGXC_NODE_NODE_ID_INDEX_ID_NBUCKETS 256
#define WORKLOAD_GROUP_GROUP_NAME_INDEX_ID_NBUCKETS 256
#define WORKLOAD_GROUP_OID_INDEX_ID_NBUCKETS 256
#define PGXC_SLICE_INDEX_ID_NBUCKETS 1024
#define STATISTIC_RELID_KIND_ATTNUM_INH_INDEX_ID_NBUCKETS 1024
#define STATISTIC_EXT_RELID_KIND_INH_KEY_INDEX_ID_NBUCKETS 1024
#define PACKAGE_OID_INDEX_ID_NBUCKETS 2048
#define PACKAGE_NAME_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_DEFRELID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_ID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_LOOKUP_ID_XID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_MATRELID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_OID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_RELID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CONT_QUERY_SCHEMA_CHANGE_INDEX_ID_NBUCKETS 2048
#define STREAMING_STREAM_OID_INDEX_ID_NBUCKETS 2048
#define STREAMING_STREAM_RELID_INDEX_ID_NBUCKETS 2048
#define STREAMING_REAPER_STATUS_OID_INDEX_ID_NBUCKETS 2048
#define STREAMING_CQ_REAPER_STATUS_OID_INDEX_ID_NBUCKETS 2048
#endif


#endif /* MEMORY_LITE_H */
